Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 791)
@@ -4,6 +4,6 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :  1.0  !  02-06  (G. Madec) from traadv_muscl
-   !!            2.4  !  08-01  (G. Madec) Merge TRA-TRC
+   !! History :  1.0  !  2002-06  (G. Madec) from traadv_muscl
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -26,5 +26,4 @@
    PRIVATE
 
-   !! * Accessibility
    PUBLIC tra_adv_muscl2        ! routine called by step.F90
 
@@ -34,5 +33,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -66,8 +65,8 @@
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zu, zv, zw, zeu, zev
-      REAL(wp) ::   zew, zbtr, zstep, z2 
+      REAL(wp) ::   zu, zv, zw
+      REAL(wp) ::   zbtr, zstep, z2 
       REAL(wp) ::   z0u, z0v, z0w
-      REAL(wp) ::   zzwx, zzwy, zalpha, zta
+      REAL(wp) ::   zzwx, zzwy, zalpha
       REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zwx, zwy, zslpx, zslpy   ! 3D workspace
       !!----------------------------------------------------------------------
@@ -98,4 +97,5 @@
       zwx(:,:,jpk) = 0.e0    ;    zwy(:,:,jpk) = 0.e0        ! bottom values
 
+!!gm  this lbc_lnk can be omitted
       ! lateral boundary conditions on zwx, zwy   (changed sign)
       CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )
@@ -117,12 +117,10 @@
          DO jj = 2, jpj
             DO ji = fs_2, jpi   ! vector opt.
-               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) )   &
-                  &            * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
-                  &                   2.*ABS( zwx (ji-1,jj,jk) ),   &
-                  &                   2.*ABS( zwx (ji  ,jj,jk) ) )
-               zslpy(ji,jj,jk) = SIGN( 1., zslpy(ji,jj,jk) )   &
-                  &            * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
-                  &                   2.*ABS( zwy (ji,jj-1,jk) ),   &
-                  &                   2.*ABS( zwy (ji,jj  ,jk) ) )
+               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
+                  &                                                 2.*ABS( zwx  (ji-1,jj,jk) ),   &
+                  &                                                 2.*ABS( zwx  (ji  ,jj,jk) ) )
+               zslpy(ji,jj,jk) = SIGN( 1., zslpy(ji,jj,jk) ) * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
+                  &                                                 2.*ABS( zwy  (ji,jj-1,jk) ),   &
+                  &                                                 2.*ABS( zwy  (ji,jj  ,jk) ) )
             END DO
          END DO
@@ -134,26 +132,17 @@
          DO jj = 2, jpjm1      
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! volume fluxes
-#if defined key_zco
-               zeu = e2u(ji,jj)                   * pun(ji,jj,jk)
-               zev = e1v(ji,jj)                   * pvn(ji,jj,jk)
-#else
-               zeu = e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-#endif
-               ! MUSCL fluxes
-               z0u = SIGN( 0.5, pun(ji,jj,jk) )            
+               z0u  = SIGN( 0.5, pun(ji,jj,jk) )            
                zalpha = 0.5 - z0u
-               zu  = z0u - 0.5 * pun(ji,jj,jk) * zstep / e1u(ji,jj)
-               zzwx = ptb(ji+1,jj,jk) + zu*zslpx(ji+1,jj,jk)
-               zzwy = ptb(ji  ,jj,jk) + zu*zslpx(ji  ,jj,jk)
-               zwx(ji,jj,jk) = zeu * ( zalpha * zzwx + (1.-zalpha) * zzwy )
+               zu   = z0u - 0.5 * pun(ji,jj,jk) * zstep / ( e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk) )
+               zzwx = ptb(ji+1,jj,jk) + zu * zslpx(ji+1,jj,jk)
+               zzwy = ptb(ji  ,jj,jk) + zu * zslpx(ji  ,jj,jk)
+               zwx(ji,jj,jk) = pun(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
                !
                z0v = SIGN( 0.5, pvn(ji,jj,jk) )            
                zalpha = 0.5 - z0v
-               zv  = z0v - 0.5 * pvn(ji,jj,jk) * zstep / e2v(ji,jj)
-               zzwx = ptb(ji,jj+1,jk) + zv*zslpy(ji,jj+1,jk)
-               zzwy = ptb(ji,jj  ,jk) + zv*zslpy(ji,jj  ,jk)
-               zwy(ji,jj,jk) = zev * ( zalpha * zzwx + (1.-zalpha) * zzwy )
+               zv   = z0v - 0.5 * pvn(ji,jj,jk) * zstep / ( e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk) )
+               zzwx = ptb(ji,jj+1,jk) + zv * zslpy(ji,jj+1,jk)
+               zzwy = ptb(ji,jj  ,jk) + zv * zslpy(ji,jj  ,jk)
+               zwy(ji,jj,jk) = pvn(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
             END DO
          END DO
@@ -166,43 +155,20 @@
         DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
                IF( umask(ji,jj,jk) == 0. ) THEN
                   IF( pun(ji+1,jj,jk) > 0. .AND. ji /= jpi ) THEN
-                     zwx(ji+1,jj,jk) = e2u(ji+1,jj) * pun(ji+1,jj,jk) * ( ptn(ji+1,jj,jk) + ptn(ji+2,jj,jk) ) * 0.5
+                     zwx(ji+1,jj,jk) = pun(ji+1,jj,jk) * ( ptn(ji+1,jj,jk) + ptn(ji+2,jj,jk) ) * 0.5
                   ENDIF
                   IF( pun(ji-1,jj,jk) < 0. ) THEN
-                     zwx(ji-1,jj,jk) = e2u(ji-1,jj) * pun(ji-1,jj,jk) * ( ptn(ji-1,jj,jk) + ptn(ji  ,jj,jk) ) * 0.5
+                     zwx(ji-1,jj,jk) = pun(ji-1,jj,jk) * ( ptn(ji-1,jj,jk) + ptn(ji  ,jj,jk) ) * 0.5
                   ENDIF
                ENDIF
                IF( vmask(ji,jj,jk) == 0. ) THEN
                   IF( pvn(ji,jj+1,jk) > 0. .AND. jj /= jpj ) THEN
-                     zwy(ji,jj+1,jk) = e1v(ji,jj+1) * pvn(ji,jj+1,jk) * ( ptn(ji,jj+1,jk) + ptn(ji,jj+2,jk) ) * 0.5
+                     zwy(ji,jj+1,jk) = pvn(ji,jj+1,jk) * ( ptn(ji,jj+1,jk) + ptn(ji,jj+2,jk) ) * 0.5
                   ENDIF
                   IF( pvn(ji,jj-1,jk) < 0. ) THEN
-                     zwy(ji,jj-1,jk) = e1v(ji,jj-1) * pvn(ji,jj-1,jk) * ( ptn(ji,jj-1,jk) + ptn(ji  ,jj,jk) ) * 0.5
+                     zwy(ji,jj-1,jk) = pvn(ji,jj-1,jk) * ( ptn(ji,jj-1,jk) + ptn(ji  ,jj,jk) ) * 0.5
                   ENDIF
                ENDIF
-#else
-               IF( umask(ji,jj,jk) == 0. ) THEN
-                  IF( pun(ji+1,jj,jk) > 0. .AND. ji /= jpi ) THEN
-                     zwx(ji+1,jj,jk) = e2u(ji+1,jj)* fse3u(ji+1,jj,jk)   &
-                        &            * pun(ji+1,jj,jk) * ( ptn(ji+1,jj,jk) + ptn(ji+2,jj,jk) ) * 0.5
-                  ENDIF
-                  IF( pun(ji-1,jj,jk) < 0. ) THEN
-                     zwx(ji-1,jj,jk) = e2u(ji-1,jj)* fse3u(ji-1,jj,jk)   &
-                        &            * pun(ji-1,jj,jk) * ( ptn(ji-1,jj,jk) + ptn(ji  ,jj,jk) ) * 0.5
-                  ENDIF
-               ENDIF
-               IF( vmask(ji,jj,jk) == 0. ) THEN
-                  IF( pvn(ji,jj+1,jk) > 0. .AND. jj /= jpj ) THEN
-                     zwy(ji,jj+1,jk) = e1v(ji,jj+1) * fse3v(ji,jj+1,jk)   &
-                        &            * pvn(ji,jj+1,jk) * ( ptn(ji,jj+1,jk) + ptn(ji,jj+2,jk) ) * 0.5
-                  ENDIF
-                  IF( pvn(ji,jj-1,jk) < 0. ) THEN
-                     zwy(ji,jj-1,jk) = e1v(ji,jj-1)* fse3v(ji,jj-1,jk)   &
-                        &            * pvn(ji,jj-1,jk) * ( ptn(ji,jj-1,jk) + ptn(ji  ,jj,jk) ) * 0.5
-                  ENDIF
-               ENDIF
-#endif
             END DO
          END DO
@@ -217,14 +183,8 @@
          DO jj = 2, jpjm1      
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zbtr = 1. / ( e1t(ji,jj)*e2t(ji,jj) )
-#else
                zbtr = 1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
-#endif
-               ! horizontal advective trends
-               zta = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
-                  &           + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) ) 
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + zta
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                  &                                   + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) ) 
             END DO
         END DO
@@ -270,5 +230,5 @@
             DO ji = 1, jpi
                zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji,jj,jk+1) )   &
-                  &           * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
+                  &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
             END DO
          END DO
@@ -279,8 +239,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) )   &
-                  &           * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
-                  &                  2.*ABS( zwx (ji,jj,jk+1) ),   &
-                  &                  2.*ABS( zwx (ji,jj,jk  ) ) )
+               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
+                  &                                                 2.*ABS( zwx  (ji,jj,jk+1) ),   &
+                  &                                                 2.*ABS( zwx  (ji,jj,jk  ) ) )
             END DO
          END DO
@@ -293,11 +252,10 @@
          DO jj = 2, jpjm1      
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zew = pwn(ji,jj,jk+1)
                z0w = SIGN( 0.5, pwn(ji,jj,jk+1) )
                zalpha = 0.5 + z0w
-               zw  = z0w - 0.5 * pwn(ji,jj,jk+1)*zstep / fse3w(ji,jj,jk+1)
-               zzwx = ptb(ji,jj,jk+1) + zw*zslpx(ji,jj,jk+1)
-               zzwy = ptb(ji,jj,jk  ) + zw*zslpx(ji,jj,jk  )
-               zwx(ji,jj,jk+1) = zew * ( zalpha * zzwx + (1.-zalpha)*zzwy )
+               zw  = z0w - 0.5 * pwn(ji,jj,jk+1)*zstep / ( e1t(ji,jj) *e2t(ji,jj) * fse3w(ji,jj,jk+1) )
+               zzwx = ptb(ji,jj,jk+1) + zw * zslpx(ji,jj,jk+1)
+               zzwy = ptb(ji,jj,jk  ) + zw * zslpx(ji,jj,jk  )
+               zwx(ji,jj,jk+1) = pwn(ji,jj,jk+1) * ( zalpha * zzwx + (1.-zalpha)*zzwy )
             END DO
          END DO
@@ -315,12 +273,9 @@
       END DO
 
-      ! surface values
-      IF( lk_dynspg_rl .OR. lk_vvl ) THEN              ! rigid lid or variable volume: flux set to zero
-         zwx(:,:, 1 ) = 0.e0                                 ! surface
-         zwx(:,:,jpk) = 0.e0                                 ! bottom 
-      ELSE                                             ! free surface
-         zwx(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1)               ! surface
-         zwx(:,:,jpk) = 0.e0                                 ! bottom 
-      ENDIF
+      zwx(:,:,jpk) = 0.e0                                       ! bottom value
+      !                                                         ! surface values
+      IF( lk_dynspg_rl .OR. lk_vvl) THEN    ;   zwx(:,:, 1 ) = 0.e0                      ! rigid lid or variable volume
+      ELSE                                  ;   zwx(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1)   ! linear free surface
+      ENDIF 
 
 
@@ -330,8 +285,6 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zbtr = 1. / fse3t(ji,jj,jk)
-               ! horizontal advective trends
-               zta = - zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) =  pta(ji,jj,jk) + zta
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) =  pta(ji,jj,jk) - zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
             END DO
          END DO
